diff --git a/hardware/openzwave/command_classes/SimpleAVCommandItem.h b/hardware/openzwave/command_classes/SimpleAVCommandItem.h
new file mode 100644
index 0000000000..b93bee8e46
--- /dev/null
+++ b/hardware/openzwave/command_classes/SimpleAVCommandItem.h
@@ -0,0 +1,25 @@
+#include <string>
+#include <vector>
+#include "Defs.h"
+
+namespace OpenZWave
+{
+	class SimpleAVCommandItem
+	{
+	public:
+		SimpleAVCommandItem(uint16 const _code, string _name, string _description, uint16 const _version);
+		uint16 GetCode();
+		string GetName();
+		string GetDescription();
+		uint16 GetVersion();
+
+		static vector<SimpleAVCommandItem> GetCommands();
+
+	private:
+		uint16 m_code;
+		string m_name;
+		string m_description;
+		uint16 m_version;
+	};
+}
+
diff --git a/hardware/openzwave/command_classes/SoundSwitch.h b/hardware/openzwave/command_classes/SoundSwitch.h
new file mode 100644
index 0000000000..d0ff41a72a
--- /dev/null
+++ b/hardware/openzwave/command_classes/SoundSwitch.h
@@ -0,0 +1,76 @@
+//-----------------------------------------------------------------------------
+//
+//	SoundSwitch.h
+//
+//	Implementation of the Z-Wave COMMAND_CLASS_SOUND_SWITCH
+//
+//	Copyright (c) 2014 Justin Hammond <Justin@dynam.ac>
+//
+//	SOFTWARE NOTICE AND LICENSE
+//
+//	This file is part of OpenZWave.
+//
+//	OpenZWave is free software: you can redistribute it and/or modify
+//	it under the terms of the GNU Lesser General Public License as published
+//	by the Free Software Foundation, either version 3 of the License,
+//	or (at your option) any later version.
+//
+//	OpenZWave is distributed in the hope that it will be useful,
+//	but WITHOUT ANY WARRANTY; without even the implied warranty of
+//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//	GNU Lesser General Public License for more details.
+//
+//	You should have received a copy of the GNU Lesser General Public License
+//	along with OpenZWave.  If not, see <http://www.gnu.org/licenses/>.
+//
+//-----------------------------------------------------------------------------
+
+#ifndef _SoundSwitch_H
+#define _SoundSwitch_H
+
+#include "command_classes/CommandClass.h"
+
+namespace OpenZWave
+{
+	class ValueByte;
+	class ValueList;
+
+	/** \brief Implements COMMAND_CLASS_SOUND_SWITCH (0x79), a Z-Wave device command class.
+	 * \ingroup CommandClass
+	 */
+	class SoundSwitch: public CommandClass
+	{
+	private:
+		struct SoundSwitchToneInfo {
+			uint16 duration;
+			string name;
+		};
+	public:
+		static CommandClass* Create( uint32 const _homeId, uint8 const _nodeId ){ return new SoundSwitch( _homeId, _nodeId ); }
+		virtual ~SoundSwitch(){}
+
+		static uint8 const StaticGetCommandClassId(){ return 0x79; }
+		static string const StaticGetCommandClassName(){ return "COMMAND_CLASS_SOUND_SWITCH"; }
+
+		// From CommandClass
+		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
+		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
+		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
+		virtual bool SetValue( Value const& _value );
+
+	protected:
+		virtual void CreateVars( uint8 const _instance );
+
+	private:
+		SoundSwitch( uint32 const _homeId, uint8 const _nodeId );
+
+		uint8 m_toneCount;
+		std::map<uint8, SoundSwitchToneInfo> m_toneInfo;
+	};
+
+} // namespace OpenZWave
+
+#endif
+
diff --git a/hardware/openzwave/command_classes/SwitchAll.h b/hardware/openzwave/command_classes/SwitchAll.h
index 55b031929d..5c98ae44d4 100644
--- a/hardware/openzwave/command_classes/SwitchAll.h
+++ b/hardware/openzwave/command_classes/SwitchAll.h
@@ -35,6 +35,7 @@ namespace OpenZWave
 	class ValueList;
 
 	/** \brief Implements COMMAND_CLASS_SWITCH_ALL (0x27), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class SwitchAll: public CommandClass
 	{
@@ -50,7 +51,7 @@ namespace OpenZWave
 
 		// From CommandClass
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
diff --git a/hardware/openzwave/command_classes/SwitchBinary.h b/hardware/openzwave/command_classes/SwitchBinary.h
index 731af6488d..c686bd78cc 100644
--- a/hardware/openzwave/command_classes/SwitchBinary.h
+++ b/hardware/openzwave/command_classes/SwitchBinary.h
@@ -35,6 +35,7 @@ namespace OpenZWave
 	class ValueBool;
 
 	/** \brief Implements COMMAND_CLASS_SWITCH_BINARY (0x25), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class SwitchBinary: public CommandClass
 	{
@@ -47,13 +48,16 @@ namespace OpenZWave
 
 		// From CommandClass
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
 		virtual bool SetValue( Value const& _value );
 		virtual void SetValueBasic( uint8 const _instance, uint8 const _value );
+		bool SetState( uint8 const _instance, bool const _state );
 
+		virtual uint8 GetMaxVersion(){ return 2; }
+		
 	protected:
 		virtual void CreateVars( uint8 const _instance );
 
diff --git a/hardware/openzwave/command_classes/SwitchMultilevel.h b/hardware/openzwave/command_classes/SwitchMultilevel.h
index 43cafb570b..8b52133c63 100644
--- a/hardware/openzwave/command_classes/SwitchMultilevel.h
+++ b/hardware/openzwave/command_classes/SwitchMultilevel.h
@@ -37,6 +37,7 @@ namespace OpenZWave
 	class ValueByte;
 
 	/** \brief Implements COMMAND_CLASS_SWITCH_MULTILEVEL (0x26), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class SwitchMultilevel: public CommandClass
 	{
@@ -49,15 +50,16 @@ namespace OpenZWave
 
 		// From CommandClass
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
+		virtual bool HandleIncomingMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
 		virtual bool SetValue( Value const& _value );
 		virtual void SetValueBasic( uint8 const _instance, uint8 const _value );
 		virtual void SetVersion( uint8 const _version );
 
-		virtual uint8 GetMaxVersion(){ return 3; }
+		virtual uint8 GetMaxVersion(){ return 4; }
 
 	protected:
 		virtual void CreateVars( uint8 const _instance );
diff --git a/hardware/openzwave/command_classes/SwitchToggleBinary.h b/hardware/openzwave/command_classes/SwitchToggleBinary.h
index fa435d9ee3..6634e1cfc2 100644
--- a/hardware/openzwave/command_classes/SwitchToggleBinary.h
+++ b/hardware/openzwave/command_classes/SwitchToggleBinary.h
@@ -35,6 +35,7 @@ namespace OpenZWave
 	class ValueBool;
 
 	/** \brief Implements COMMAND_CLASS_SWITCH_TOGGLE_BINARY (0x28), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class SwitchToggleBinary: public CommandClass
 	{
@@ -47,7 +48,7 @@ namespace OpenZWave
 
 		// From CommandClass
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
diff --git a/hardware/openzwave/command_classes/SwitchToggleMultilevel.h b/hardware/openzwave/command_classes/SwitchToggleMultilevel.h
index cf5d734dce..eeedd6c048 100644
--- a/hardware/openzwave/command_classes/SwitchToggleMultilevel.h
+++ b/hardware/openzwave/command_classes/SwitchToggleMultilevel.h
@@ -35,6 +35,7 @@ namespace OpenZWave
 	class ValueByte;
 
 	/** \brief Implements COMMAND_CLASS_SWITCH_TOGGLE_MULTILEVEL (0x29), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class SwitchToggleMultilevel: public CommandClass
 	{
@@ -56,7 +57,7 @@ namespace OpenZWave
 
 		// From CommandClass
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
diff --git a/hardware/openzwave/command_classes/ThermostatFanMode.h b/hardware/openzwave/command_classes/ThermostatFanMode.h
index bfd3e07fb5..81bc45152e 100644
--- a/hardware/openzwave/command_classes/ThermostatFanMode.h
+++ b/hardware/openzwave/command_classes/ThermostatFanMode.h
@@ -38,6 +38,7 @@ namespace OpenZWave
 	class ValueList;
 
 	/** \brief Implements COMMAND_CLASS_THERMOSTAT_FAN_MODE (0x44), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class ThermostatFanMode: public CommandClass
 	{
@@ -52,7 +53,7 @@ namespace OpenZWave
 		virtual void ReadXML( TiXmlElement const* _ccElement );
 		virtual void WriteXML( TiXmlElement* _ccElement );
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _getTypeEnum, uint8 const _dummy, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _getTypeEnum, uint8 const _dummy, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
diff --git a/hardware/openzwave/command_classes/ThermostatFanState.h b/hardware/openzwave/command_classes/ThermostatFanState.h
index 5866348f01..853cc5a656 100644
--- a/hardware/openzwave/command_classes/ThermostatFanState.h
+++ b/hardware/openzwave/command_classes/ThermostatFanState.h
@@ -38,6 +38,7 @@ namespace OpenZWave
 	class ValueString;
 
 	/** \brief Implements COMMAND_CLASS_THERMOSTAT_FAN_STATE (0x45), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class ThermostatFanState: public CommandClass
 	{
@@ -50,7 +51,7 @@ namespace OpenZWave
 
 		// From CommandClass
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
diff --git a/hardware/openzwave/command_classes/ThermostatMode.h b/hardware/openzwave/command_classes/ThermostatMode.h
index 8c6693a9dc..48bdabb680 100644
--- a/hardware/openzwave/command_classes/ThermostatMode.h
+++ b/hardware/openzwave/command_classes/ThermostatMode.h
@@ -38,6 +38,7 @@ namespace OpenZWave
 	class ValueList;
 
 	/** \brief Implements COMMAND_CLASS_THERMOSTAT_MODE (0x40), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class ThermostatMode: public CommandClass
 	{
@@ -52,11 +53,12 @@ namespace OpenZWave
 		virtual void ReadXML( TiXmlElement const* _ccElement );
 		virtual void WriteXML( TiXmlElement* _ccElement );
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _getTypeEnum, uint8 const _dummy, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _getTypeEnum, uint8 const _dummy, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
 		virtual bool SetValue( Value const& _value );
+		virtual uint8 GetMaxVersion(){ return 3; }
 
 	protected:
 		virtual void CreateVars( uint8 const _instance );
diff --git a/hardware/openzwave/command_classes/ThermostatOperatingState.h b/hardware/openzwave/command_classes/ThermostatOperatingState.h
index ee4d39a05e..c160e41a4b 100644
--- a/hardware/openzwave/command_classes/ThermostatOperatingState.h
+++ b/hardware/openzwave/command_classes/ThermostatOperatingState.h
@@ -38,6 +38,7 @@ namespace OpenZWave
 	class ValueString;
 
 	/** \brief Implements COMMAND_CLASS_THERMOSTAT_OPERATING_STATE (0x42), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class ThermostatOperatingState: public CommandClass
 	{
@@ -50,7 +51,7 @@ namespace OpenZWave
 
 		// From CommandClass
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
diff --git a/hardware/openzwave/command_classes/ThermostatSetpoint.h b/hardware/openzwave/command_classes/ThermostatSetpoint.h
index 595e0d30dc..dde217ee37 100644
--- a/hardware/openzwave/command_classes/ThermostatSetpoint.h
+++ b/hardware/openzwave/command_classes/ThermostatSetpoint.h
@@ -37,6 +37,7 @@ namespace OpenZWave
 	class ValueDecimal;
 
 	/** \brief Implements COMMAND_CLASS_THERMOSTAT_SETPOINT (0x43), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class ThermostatSetpoint: public CommandClass
 	{
@@ -48,21 +49,19 @@ namespace OpenZWave
 		static string const StaticGetCommandClassName(){ return "COMMAND_CLASS_THERMOSTAT_SETPOINT"; }
 
 		// From CommandClass
-		virtual void ReadXML( TiXmlElement const* _ccElement );
-		virtual void WriteXML( TiXmlElement* _ccElement );
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _setPointIndex, uint8 const _dummy, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _setPointIndex, uint8 const _dummy, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
 		virtual bool SetValue( Value const& _value );
+		virtual uint8 GetMaxVersion(){ return 3; }
 
 	public:
 		virtual void CreateVars( uint8 const _instance, uint8 const _index );
 
 	private:
 		ThermostatSetpoint( uint32 const _homeId, uint8 const _nodeId );
-		uint8 m_setPointBase;
 	};
 
 } // namespace OpenZWave
diff --git a/hardware/openzwave/command_classes/TimeParameters.h b/hardware/openzwave/command_classes/TimeParameters.h
index e0ff6df078..1d2f10d3c1 100644
--- a/hardware/openzwave/command_classes/TimeParameters.h
+++ b/hardware/openzwave/command_classes/TimeParameters.h
@@ -36,6 +36,7 @@ namespace OpenZWave
 	class ValueList;
 
 	/** \brief Implements COMMAND_CLASS_TIME_PARAMETERS (0x8B), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class TimeParameters: public CommandClass
 	{
@@ -48,7 +49,7 @@ namespace OpenZWave
 
 		// From CommandClass
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
diff --git a/hardware/openzwave/command_classes/UserCode.h b/hardware/openzwave/command_classes/UserCode.h
index 6f44980bea..175bbd3af7 100644
--- a/hardware/openzwave/command_classes/UserCode.h
+++ b/hardware/openzwave/command_classes/UserCode.h
@@ -33,19 +33,24 @@
 namespace OpenZWave
 {
 	/** \brief Implements COMMAND_CLASS_USER_CODE (0x63), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class UserCode: public CommandClass
 	{
-	public:
+	private:
 		enum UserCodeStatus
 		{
 			UserCode_Available		= 0x00,
 			UserCode_Occupied		= 0x01,
 			UserCode_Reserved		= 0x02,
-			UserCode_NotAvailable		= 0xfe,
+			UserCode_NotAvailable	= 0xfe,
 			UserCode_Unset			= 0xff
 		};
-
+		struct UserCodeEntry {
+			UserCodeStatus status;
+			uint8 usercode[10];
+		};
+	public:
 		static CommandClass* Create( uint32 const _homeId, uint8 const _nodeId ){ return new UserCode( _homeId, _nodeId ); }
 		virtual ~UserCode(){}
 
@@ -53,10 +58,8 @@ namespace OpenZWave
 		static string const StaticGetCommandClassName(){ return "COMMAND_CLASS_USER_CODE"; }
 
 		// From CommandClass
-		virtual void ReadXML( TiXmlElement const* _ccElement );
-		virtual void WriteXML( TiXmlElement* _ccElement );
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
@@ -100,9 +103,8 @@ namespace OpenZWave
 		}
 
 		bool		m_queryAll;				// True while we are requesting all the user codes.
-		uint8		m_currentCode;
-		uint8		m_userCodeCount;
-		uint8		m_userCodesStatus[256];
+		uint16		m_currentCode;
+		std::map<uint16, UserCodeEntry>	m_userCode;
 		bool		m_refreshUserCodes;
 	};
 
diff --git a/hardware/openzwave/command_classes/Version.h b/hardware/openzwave/command_classes/Version.h
index b3591ad1a5..14d0fb59b2 100644
--- a/hardware/openzwave/command_classes/Version.h
+++ b/hardware/openzwave/command_classes/Version.h
@@ -35,6 +35,7 @@ namespace OpenZWave
 	class ValueString;
 
 	/** \brief Implements COMMAND_CLASS_VERSION (0x86), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class Version: public CommandClass
 	{
@@ -48,10 +49,8 @@ namespace OpenZWave
 		bool RequestCommandClassVersion( CommandClass const* _commandClass );
 
 		// From CommandClass
-		virtual void ReadXML( TiXmlElement const* _ccElement );
-		virtual void WriteXML( TiXmlElement* _ccElement );
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
@@ -61,8 +60,6 @@ namespace OpenZWave
 
 	private:
 		Version( uint32 const _homeId, uint8 const _nodeId );
-
-		bool m_classGetSupported;
 	};
 
 } // namespace OpenZWave
diff --git a/hardware/openzwave/command_classes/WakeUp.h b/hardware/openzwave/command_classes/WakeUp.h
index 12152d621d..727a610ec0 100644
--- a/hardware/openzwave/command_classes/WakeUp.h
+++ b/hardware/openzwave/command_classes/WakeUp.h
@@ -31,6 +31,7 @@
 #include <list>
 #include "command_classes/CommandClass.h"
 #include "Driver.h"
+#include "TimerThread.h"
 
 namespace OpenZWave
 {
@@ -39,8 +40,9 @@ namespace OpenZWave
 	class Mutex;
 
 	/** \brief Implements COMMAND_CLASS_WAKE_UP (0x84), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
-	class WakeUp: public CommandClass
+	class WakeUp: public CommandClass, private Timer
 	{
 	public:
 		static CommandClass* Create( uint32 const _homeId, uint8 const _nodeId ){ return new WakeUp( _homeId, _nodeId ); }
@@ -51,14 +53,20 @@ namespace OpenZWave
 
 		void Init();	// Starts the process of requesting node state from a sleeping device.
 		void QueueMsg( Driver::MsgQueueItem const& _item );
+
+		/** \brief Send all pending messages followed by a no more information message. */
 		void SendPending();
+
+		/** \brief Send a no more information message. */
+		void SendNoMoreInfo(uint32 id);
+
 		bool IsAwake()const{ return m_awake; }
 		void SetAwake( bool _state );
 		void SetPollRequired(){ m_pollRequired = true; }
 
 		// From CommandClass
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
diff --git a/hardware/openzwave/command_classes/ZWavePlusInfo.h b/hardware/openzwave/command_classes/ZWavePlusInfo.h
index ac9214a5c4..f0e38dbfc5 100644
--- a/hardware/openzwave/command_classes/ZWavePlusInfo.h
+++ b/hardware/openzwave/command_classes/ZWavePlusInfo.h
@@ -33,6 +33,7 @@
 namespace OpenZWave
 {
 	/** \brief Implements COMMAND_CLASS_ZWAVEPLUS_INFO (0x5E), a Z-Wave device command class.
+	 * \ingroup CommandClass
 	 */
 	class ZWavePlusInfo: public CommandClass
 	{
@@ -45,7 +46,7 @@ namespace OpenZWave
 
 		// From CommandClass
 		virtual bool RequestState( uint32 const _requestFlags, uint8 const _instance, Driver::MsgQueue const _queue );
-		virtual bool RequestValue( uint32 const _requestFlags, uint8 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
+		virtual bool RequestValue( uint32 const _requestFlags, uint16 const _index, uint8 const _instance, Driver::MsgQueue const _queue );
 		virtual uint8 const GetCommandClassId()const{ return StaticGetCommandClassId(); }
 		virtual string const GetCommandClassName()const{ return StaticGetCommandClassName(); }
 		virtual bool HandleMsg( uint8 const* _data, uint32 const _length, uint32 const _instance = 1 );
diff --git a/hardware/openzwave/platform/Controller.h b/hardware/openzwave/platform/Controller.h
index ee80880e70..89221eacb4 100644
--- a/hardware/openzwave/platform/Controller.h
+++ b/hardware/openzwave/platform/Controller.h
@@ -38,11 +38,22 @@ namespace OpenZWave
 {
 	class Driver;
 
+	/** \defgroup Platform Platform Abstraction Support
+	 *
+	 * These files abstract differences in platforms that OZW supports
+	 *
+	 */
+
+	/** \brief Represents a USB Controller
+	 * \ingroup Platform
+	 *
+	 * Controller is derived from Stream rather than containing one, so that
+	 * we can use its Wait abilities without having to duplicate them here.
+	 * The stream is used for input.  Buffering of output is handled by the OS.
+	 */
+
 	class Controller: public Stream
 	{
-		// Controller is derived from Stream rather than containing one, so that
-		// we can use its Wait abilities without having to duplicate them here.
-		// The stream is used for input.  Buffering of output is handled by the OS. 
 
 	public:
 		/**
diff --git a/hardware/openzwave/platform/DNS.h b/hardware/openzwave/platform/DNS.h
new file mode 100644
index 0000000000..32b26a1f17
--- /dev/null
+++ b/hardware/openzwave/platform/DNS.h
@@ -0,0 +1,78 @@
+//-----------------------------------------------------------------------------
+//
+//	DNS.h
+//
+//	Cross-platform DNS Operations
+//
+//	Copyright (c) 2015 Justin Hammond <justin@dynam.ac>
+//	All rights reserved.
+//
+//	SOFTWARE NOTICE AND LICENSE
+//
+//	This file is part of OpenZWave.
+//
+//	OpenZWave is free software: you can redistribute it and/or modify
+//	it under the terms of the GNU Lesser General Public License as published
+//	by the Free Software Foundation, either version 3 of the License,
+//	or (at your option) any later version.
+//
+//	OpenZWave is distributed in the hope that it will be useful,
+//	but WITHOUT ANY WARRANTY; without even the implied warranty of
+//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+//	GNU Lesser General Public License for more details.
+//
+//	You should have received a copy of the GNU Lesser General Public License
+//	along with OpenZWave.  If not, see <http://www.gnu.org/licenses/>.
+//
+//-----------------------------------------------------------------------------
+#ifndef _DNS_H
+#define _DNS_H
+
+#include <stdarg.h>
+#include <string>
+#include "Defs.h"
+#include "platform/Log.h"
+
+
+namespace OpenZWave
+{
+	class DNSImpl;
+
+	/** \brief Return codes for DNS lookups
+	 * \ingroup Platform
+	 */
+	enum DNSError
+	{
+		DNSError_None = 0,
+		DNSError_NotFound,					/**< No Record Exists - There for no Config File exists */
+		DNSError_DomainError,					/**< Domain didn't resolve etc */
+		DNSError_InternalError					/**< A Internal Error Occured */
+	};
+
+
+	/** \brief Implements platform-independent DNS lookup Operations.
+	 * \ingroup Platform
+	 */
+	class DNS
+	{
+	public:
+			DNS();
+			~DNS();
+			/**
+			 * \brief Starts a DNS lookup for a TXT record
+			 *
+			 * This function will lookup the TXT record for a address
+			 *
+			 * \param lookup the DNS address to lookup
+			 * \param result the result of the lookup request, or empty if the lookup failed.
+			 *
+			 * \return success/failure of the Lookup request
+			 */
+			bool LookupTxT(string lookup, string &result);
+			DNSError status;
+	private:
+			DNSImpl *m_pImpl;
+	};
+}
+
+#endif
diff --git a/hardware/openzwave/platform/Event.h b/hardware/openzwave/platform/Event.h
index 534d396073..a026608d73 100644
--- a/hardware/openzwave/platform/Event.h
+++ b/hardware/openzwave/platform/Event.h
@@ -35,6 +35,7 @@ namespace OpenZWave
 	class EventImpl;
 
 	/** \brief Platform-independent definition of event objects.
+	 * \ingroup Platform
 	 */
 	class Event: public Wait
 	{
diff --git a/hardware/openzwave/platform/FileOps.h b/hardware/openzwave/platform/FileOps.h
index 79bf06d599..106b5e6f1c 100644
--- a/hardware/openzwave/platform/FileOps.h
+++ b/hardware/openzwave/platform/FileOps.h
@@ -37,6 +37,7 @@ namespace OpenZWave
 	class FileOpsImpl;
 
 	/** \brief Implements platform-independent File Operations.
+	 * \ingroup Platform
 	 */
 	class FileOps
 	{
@@ -55,12 +56,50 @@ namespace OpenZWave
 		static void Destroy();
 
 		/**
-		 * FolderExists. Check for the existance of a folder.
+		 * FolderExists. Check for the existence of a folder.
 		 * \param string. Folder name.
-		 * \return Bool value indicating existance.
+		 * \return Bool value indicating existence.
 		 */
 		static bool FolderExists( const string &_folderName );
 
+		/**
+		 * FileExists. Check for the existence of a file.
+		 * \param string. file name.
+		 * \return Bool value indicating existence.
+		 */
+		static bool FileExists( const string &_fileName );
+
+		/**
+		 * FileWriteable. Check if we can write to a file.
+		 * \param string. file name.
+		 * \return Bool value indicating write permissions.
+		 */
+		static bool FileWriteable( const string &_fileName );
+
+		/**
+		 * FileRotate. Rotate a File
+		 * \param string. file name.
+		 * \return Bool value indicating write permissions.
+		 */
+		static bool FileRotate( const string &_fileName );
+
+		/**
+		 * FileCopy. Copy a File
+		 * \param string. source file name.
+		 * \param string. destination file name
+		 * \return Bool value indicating success.
+		 */
+		static bool FileCopy( const string &_fileName, const string &_destinationfile );
+
+		/**
+		 * FolderCreate. Create a Folder
+		 * \param string. folder name
+		 * \return Bool value indicating success.
+		 */
+		static bool FolderCreate( const string &_folderName);
+
+
+
 	private:
 		FileOps();
 		~FileOps();
diff --git a/hardware/openzwave/platform/HidController.h b/hardware/openzwave/platform/HidController.h
index b2460573fb..4e6de28872 100644
--- a/hardware/openzwave/platform/HidController.h
+++ b/hardware/openzwave/platform/HidController.h
@@ -44,6 +44,10 @@ namespace OpenZWave
 	class Thread;
 	class Event;
 
+
+	/** \brief Interface for controllers that implement a HID emulation
+	 * \ingroup Platform
+	 */
 	class HidController: public Controller
 	{
 	public:
